/*******************************************************************************
 * This file was auto-generated using the AutoGemm.py python script.
 * DO NOT modify this file! Instead, make changes to scripts in
 *   clBLAS/src/library/blas/AutoGemm/ then re-generate files
 *   (otherwise local changes will be lost after re-generation).
 ******************************************************************************/

#include "AutoGemmIncludes/AutoGemmKernelSelection.h"

// sgemm kernel selection logic
template<>
void gemmSelectKernel<float>(
  clblasOrder order,
  clblasTranspose transA,
  clblasTranspose transB,
  size_t M,
  size_t N,
  size_t K,
  bool betaNonZero,
  float optimalNumElementsPerWorkItem,
  const char **tileKernelSource,
  const char **rowKernelSource,
  const char **colKernelSource,
  const char **cornerKernelSource,
  const char **sourceBuildOptions,
  const unsigned char **tileKernelBinary,
  const unsigned char **rowKernelBinary,
  const unsigned char **colKernelBinary,
  const unsigned char **cornerKernelBinary,
  size_t **tileKernelBinarySize,
  size_t **rowKernelBinarySize,
  size_t **colKernelBinarySize,
  size_t **cornerKernelBinarySize,
  const char **binaryBuildOptions,
  cl_kernel  **tileClKernel,
  cl_kernel  **rowClKernel,
  cl_kernel  **colClKernel,
  cl_kernel  **cornerClKernel,
  unsigned int *workGroupNumRows,
  unsigned int *workGroupNumCols,
  unsigned int *microTileNumRows,
  unsigned int *microTileNumCols,
  unsigned int *unroll
) {
  if (order == clblasColumnMajor) {
    if (transA == clblasNoTrans) {
      if (transB == clblasNoTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 4000*4000) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2496*2496) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2448*2448) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1600*1600) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1008*1008) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 960*960) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 896*896) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 864*864) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 784*784) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 768*768) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 464*464) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 304*304) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 4000*4000) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2496*2496) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2448*2448) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1600*1600) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1008*1008) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 960*960) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 896*896) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 864*864) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 784*784) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 768*768) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 464*464) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 304*304) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 4000*4000) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2496*2496) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2448*2448) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1600*1600) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1008*1008) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 960*960) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 896*896) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 864*864) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 784*784) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 768*768) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 464*464) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 304*304) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 4000*4000) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2496*2496) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2448*2448) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1600*1600) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1008*1008) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 960*960) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 896*896) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 864*864) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 784*784) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 768*768) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 464*464) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 304*304) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
    } // end transA
    if (transA == clblasTrans) {
      if (transB == clblasNoTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 4000*4000) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2496*2496) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2448*2448) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1600*1600) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1008*1008) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 960*960) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 896*896) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 864*864) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 784*784) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 768*768) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 464*464) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 304*304) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 4000*4000) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2496*2496) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2448*2448) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1600*1600) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1008*1008) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 960*960) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 896*896) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 864*864) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 784*784) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 768*768) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 464*464) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 304*304) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 4000*4000) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2496*2496) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2448*2448) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1600*1600) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1008*1008) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 960*960) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 896*896) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 864*864) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 784*784) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 768*768) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 464*464) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 304*304) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 4000*4000) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2496*2496) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2448*2448) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1600*1600) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1008*1008) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 960*960) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 896*896) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 864*864) {
            // valid tiles
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 784*784) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 768*768) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX16_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 464*464) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX16_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX16_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 304*304) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX16_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%16 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%16 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX16_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX16_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX16_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX16_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX16_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX16_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX16_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX16_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX16_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX16_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX16_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX16_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX16_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX16_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX16_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX16_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX16_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX16_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX16_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX16_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX16_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX16_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX16_unroll;
              return;
            }
            if ( K%8 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  sgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  sgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  sgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  sgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  sgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  sgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  sgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  sgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &sgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &sgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &sgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &sgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  sgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &sgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &sgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &sgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &sgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  sgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  sgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  sgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
    } // end transA
  } // end order
} // end precision function

// dgemm kernel selection logic
template<>
void gemmSelectKernel<double>(
  clblasOrder order,
  clblasTranspose transA,
  clblasTranspose transB,
  size_t M,
  size_t N,
  size_t K,
  bool betaNonZero,
  float optimalNumElementsPerWorkItem,
  const char **tileKernelSource,
  const char **rowKernelSource,
  const char **colKernelSource,
  const char **cornerKernelSource,
  const char **sourceBuildOptions,
  const unsigned char **tileKernelBinary,
  const unsigned char **rowKernelBinary,
  const unsigned char **colKernelBinary,
  const unsigned char **cornerKernelBinary,
  size_t **tileKernelBinarySize,
  size_t **rowKernelBinarySize,
  size_t **colKernelBinarySize,
  size_t **cornerKernelBinarySize,
  const char **binaryBuildOptions,
  cl_kernel  **tileClKernel,
  cl_kernel  **rowClKernel,
  cl_kernel  **colClKernel,
  cl_kernel  **cornerClKernel,
  unsigned int *workGroupNumRows,
  unsigned int *workGroupNumCols,
  unsigned int *microTileNumRows,
  unsigned int *microTileNumCols,
  unsigned int *unroll
) {
  if (order == clblasColumnMajor) {
    if (transA == clblasNoTrans) {
      if (transB == clblasNoTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 5408*5408) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2800*2800) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1536*1536) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1136*1136) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 576*576) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 384*384) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 256*256) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 5408*5408) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2800*2800) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1536*1536) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1136*1136) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 576*576) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 384*384) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 256*256) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 5408*5408) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2800*2800) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1536*1536) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1136*1136) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 576*576) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 384*384) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 256*256) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 5408*5408) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2800*2800) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1536*1536) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1136*1136) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 576*576) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 384*384) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 256*256) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
    } // end transA
    if (transA == clblasTrans) {
      if (transB == clblasNoTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 5408*5408) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2800*2800) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1536*1536) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1136*1136) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 576*576) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 384*384) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 256*256) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 5408*5408) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2800*2800) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1536*1536) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1136*1136) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 576*576) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 384*384) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 256*256) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 5408*5408) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2800*2800) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1536*1536) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1136*1136) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 576*576) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 384*384) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 256*256) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 5408*5408) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2800*2800) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1536*1536) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1136*1136) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 576*576) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 384*384) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 256*256) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  dgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  dgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  dgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  dgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  dgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  dgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  dgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  dgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &dgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &dgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &dgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &dgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  dgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &dgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &dgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &dgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &dgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  dgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  dgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  dgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
    } // end transA
  } // end order
} // end precision function

// cgemm kernel selection logic
template<>
void gemmSelectKernel<FloatComplex>(
  clblasOrder order,
  clblasTranspose transA,
  clblasTranspose transB,
  size_t M,
  size_t N,
  size_t K,
  bool betaNonZero,
  float optimalNumElementsPerWorkItem,
  const char **tileKernelSource,
  const char **rowKernelSource,
  const char **colKernelSource,
  const char **cornerKernelSource,
  const char **sourceBuildOptions,
  const unsigned char **tileKernelBinary,
  const unsigned char **rowKernelBinary,
  const unsigned char **colKernelBinary,
  const unsigned char **cornerKernelBinary,
  size_t **tileKernelBinarySize,
  size_t **rowKernelBinarySize,
  size_t **colKernelBinarySize,
  size_t **cornerKernelBinarySize,
  const char **binaryBuildOptions,
  cl_kernel  **tileClKernel,
  cl_kernel  **rowClKernel,
  cl_kernel  **colClKernel,
  cl_kernel  **cornerClKernel,
  unsigned int *workGroupNumRows,
  unsigned int *workGroupNumCols,
  unsigned int *microTileNumRows,
  unsigned int *microTileNumCols,
  unsigned int *unroll
) {
  if (order == clblasColumnMajor) {
    if (transA == clblasNoTrans) {
      if (transB == clblasNoTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasConjTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_NC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_NC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_NC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_NC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_NC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_NC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_NC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_NC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_NC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_NC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_NC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_NC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_NC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_NC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_NC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_NC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_NC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_NC_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
    } // end transA
    if (transA == clblasTrans) {
      if (transB == clblasNoTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasConjTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_TC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_TC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_TC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_TC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_TC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_TC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_TC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_TC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_TC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_TC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_TC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_TC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_TC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_TC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_TC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_TC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_TC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_TC_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
    } // end transA
    if (transA == clblasConjTrans) {
      if (transB == clblasNoTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasConjTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3840*3840) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2592*2592) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX096_NX096_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML096_NX096_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX096_NL096_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML096_NL096_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX096_NX096_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX096_NX096_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML096_NX096_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX096_NL096_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML096_NL096_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX096_NX096_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML096_NX096_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX096_NL096_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML096_NL096_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX096_NX096_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX096_NX096_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML096_NX096_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX096_NL096_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML096_NL096_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX096_NX096_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX096_NX096_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX096_NX096_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX096_NX096_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX096_NX096_KX08_unroll;
              return;
            }
            if ( M%96 == 0 && N%96 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX096_NX096_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML096_NX096_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX096_NL096_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML096_NL096_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX096_NX096_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX096_NX096_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML096_NX096_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX096_NL096_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML096_NL096_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX096_NX096_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML096_NX096_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX096_NL096_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML096_NL096_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX096_NX096_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX096_NX096_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML096_NX096_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX096_NL096_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML096_NL096_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX096_NX096_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX096_NX096_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX096_NX096_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX096_NX096_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX096_NX096_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 2224*2224) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX064_NX064_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 720*720) {
            // valid tiles
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX080_NX080_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML080_NX080_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX080_NL080_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML080_NL080_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX080_NX080_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX080_NX080_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML080_NX080_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX080_NL080_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML080_NL080_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX080_NX080_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML080_NX080_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX080_NL080_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML080_NL080_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX080_NX080_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX080_NX080_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML080_NX080_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX080_NL080_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML080_NL080_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX080_NX080_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX080_NX080_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX080_NX080_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX080_NX080_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX080_NX080_KX08_unroll;
              return;
            }
            if ( M%80 == 0 && N%80 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX080_NX080_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML080_NX080_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX080_NL080_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML080_NL080_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX080_NX080_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX080_NX080_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML080_NX080_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX080_NL080_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML080_NL080_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX080_NX080_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML080_NX080_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX080_NL080_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML080_NL080_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX080_NX080_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX080_NX080_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML080_NX080_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX080_NL080_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML080_NL080_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX080_NX080_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX080_NX080_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX080_NX080_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX080_NX080_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX080_NX080_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 432*432) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 288*288) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  cgemm_Col_CC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  cgemm_Col_CC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  cgemm_Col_CC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  cgemm_Col_CC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  cgemm_Col_CC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  cgemm_Col_CC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  cgemm_Col_CC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  cgemm_Col_CC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &cgemm_Col_CC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &cgemm_Col_CC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &cgemm_Col_CC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &cgemm_Col_CC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  cgemm_Col_CC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &cgemm_Col_CC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &cgemm_Col_CC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &cgemm_Col_CC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &cgemm_Col_CC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  cgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  cgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  cgemm_Col_CC_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
    } // end transA
  } // end order
} // end precision function

// zgemm kernel selection logic
template<>
void gemmSelectKernel<DoubleComplex>(
  clblasOrder order,
  clblasTranspose transA,
  clblasTranspose transB,
  size_t M,
  size_t N,
  size_t K,
  bool betaNonZero,
  float optimalNumElementsPerWorkItem,
  const char **tileKernelSource,
  const char **rowKernelSource,
  const char **colKernelSource,
  const char **cornerKernelSource,
  const char **sourceBuildOptions,
  const unsigned char **tileKernelBinary,
  const unsigned char **rowKernelBinary,
  const unsigned char **colKernelBinary,
  const unsigned char **cornerKernelBinary,
  size_t **tileKernelBinarySize,
  size_t **rowKernelBinarySize,
  size_t **colKernelBinarySize,
  size_t **cornerKernelBinarySize,
  const char **binaryBuildOptions,
  cl_kernel  **tileClKernel,
  cl_kernel  **rowClKernel,
  cl_kernel  **colClKernel,
  cl_kernel  **cornerClKernel,
  unsigned int *workGroupNumRows,
  unsigned int *workGroupNumCols,
  unsigned int *microTileNumRows,
  unsigned int *microTileNumCols,
  unsigned int *unroll
) {
  if (order == clblasColumnMajor) {
    if (transA == clblasNoTrans) {
      if (transB == clblasNoTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasConjTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_NC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_NC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_NC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_NC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_NC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_NC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_NC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_NC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_NC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_NC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_NC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_NC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_NC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_NC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_NC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_NC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_NC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_NC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_NC_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
    } // end transA
    if (transA == clblasTrans) {
      if (transB == clblasNoTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasConjTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_TC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_TC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_TC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_TC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_TC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_TC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_TC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_TC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_TC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_TC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_TC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_TC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_TC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_TC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_TC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_TC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_TC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_TC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_TC_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
    } // end transA
    if (transA == clblasConjTrans) {
      if (transB == clblasNoTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CN_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CN_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CN_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CN_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CN_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CN_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CN_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CN_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CN_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CN_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CN_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CN_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CN_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CN_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CN_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CN_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CN_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CN_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CN_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CT_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CT_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CT_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CT_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CT_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CT_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CT_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CT_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CT_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CT_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CT_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CT_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CT_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CT_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CT_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CT_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CT_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CT_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CT_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
      if (transB == clblasConjTrans) {
        if ( !betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B0_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B0_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B0_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B0_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B0_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B0_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B0_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B0_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B0_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B0_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B0_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B0_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B0_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B0_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B0_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B0_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B0_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B0_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B0_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
        if ( betaNonZero ) {
          if ( M*N >= 3008*3008) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1344*1344) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 1040*1040) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 832*832) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX064_NX064_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML064_NX064_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX064_NL064_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML064_NL064_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX064_NX064_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX064_NX064_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML064_NX064_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX064_NL064_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML064_NL064_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX064_NX064_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML064_NX064_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX064_NL064_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML064_NL064_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX064_NX064_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX064_NX064_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML064_NX064_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX064_NL064_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML064_NL064_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX064_NX064_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX064_NX064_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX064_NX064_KX08_unroll;
              return;
            }
            if ( M%64 == 0 && N%64 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX064_NX064_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML064_NX064_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX064_NL064_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML064_NL064_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX064_NX064_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX064_NX064_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML064_NX064_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX064_NL064_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML064_NL064_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX064_NX064_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML064_NX064_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX064_NL064_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML064_NL064_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX064_NX064_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX064_NX064_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML064_NX064_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX064_NL064_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML064_NL064_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX064_NX064_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX064_NX064_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX064_NX064_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 544*544) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 336*336) {
            // valid tiles
            if ( M%48 == 0 && N%48 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX08_unroll;
              return;
            }
            if ( M%48 == 0 && N%48 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX048_NX048_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML048_NX048_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX048_NL048_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML048_NL048_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX048_NX048_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML048_NX048_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX048_NL048_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML048_NL048_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX048_NX048_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML048_NX048_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX048_NL048_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML048_NL048_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX048_NX048_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX048_NX048_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML048_NX048_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX048_NL048_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML048_NL048_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX048_NX048_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX048_NX048_KX01_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 192*192) {
            // valid tiles
            if ( M%32 == 0 && N%32 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX08_unroll;
              return;
            }
            if ( M%32 == 0 && N%32 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX032_NX032_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML032_NX032_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX032_NL032_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML032_NL032_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX032_NX032_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML032_NX032_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX032_NL032_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML032_NL032_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX032_NX032_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML032_NX032_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX032_NL032_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML032_NL032_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX032_NX032_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX032_NX032_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML032_NX032_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX032_NL032_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML032_NL032_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX032_NX032_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX032_NX032_KX01_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
          if ( M*N >= 0*0) {
            // valid tiles
            if ( M%16 == 0 && N%16 == 0 && K%8 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( M%16 == 0 && N%16 == 0 && K%1 == 0) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX016_NX016_KX01_unroll;
              return;
            }
            // fallback tile
            if ( K%8 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX016_NX016_KX08_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML016_NX016_KX08_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX016_NL016_KX08_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML016_NL016_KX08_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX08_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX016_NX016_KX08_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML016_NX016_KX08_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX016_NL016_KX08_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML016_NL016_KX08_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX016_NX016_KX08_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML016_NX016_KX08_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX016_NL016_KX08_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML016_NL016_KX08_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX08_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX016_NX016_KX08_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML016_NX016_KX08_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX016_NL016_KX08_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML016_NL016_KX08_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX08_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX08_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX016_NX016_KX08_unroll;
              return;
            }
            if ( K%1 == 0 ) {
              *tileKernelSource       =  zgemm_Col_CC_B1_MX016_NX016_KX01_src;
              *rowKernelSource        =  zgemm_Col_CC_B1_ML016_NX016_KX01_src;
              *colKernelSource        =  zgemm_Col_CC_B1_MX016_NL016_KX01_src;
              *cornerKernelSource     =  zgemm_Col_CC_B1_ML016_NL016_KX01_src;
              *sourceBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX01_srcBuildOptions;
              *tileKernelBinary       =  zgemm_Col_CC_B1_MX016_NX016_KX01_bin;
              *rowKernelBinary        =  zgemm_Col_CC_B1_ML016_NX016_KX01_bin;
              *colKernelBinary        =  zgemm_Col_CC_B1_MX016_NL016_KX01_bin;
              *cornerKernelBinary     =  zgemm_Col_CC_B1_ML016_NL016_KX01_bin;
              *tileKernelBinarySize   = &zgemm_Col_CC_B1_MX016_NX016_KX01_binSize;
              *rowKernelBinarySize    = &zgemm_Col_CC_B1_ML016_NX016_KX01_binSize;
              *colKernelBinarySize    = &zgemm_Col_CC_B1_MX016_NL016_KX01_binSize;
              *cornerKernelBinarySize = &zgemm_Col_CC_B1_ML016_NL016_KX01_binSize;
              *binaryBuildOptions     =  zgemm_Col_CC_B1_MX016_NX016_KX01_binBuildOptions;
              *tileClKernel           = &zgemm_Col_CC_B1_MX016_NX016_KX01_clKernel;
              *rowClKernel            = &zgemm_Col_CC_B1_ML016_NX016_KX01_clKernel;
              *colClKernel            = &zgemm_Col_CC_B1_MX016_NL016_KX01_clKernel;
              *cornerClKernel         = &zgemm_Col_CC_B1_ML016_NL016_KX01_clKernel;
              *workGroupNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumRows;
              *workGroupNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX01_workGroupNumCols;
              *microTileNumRows       =  zgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *microTileNumCols       =  zgemm_Col_CC_B1_MX016_NX016_KX01_microTileNumRows;
              *unroll                 =  zgemm_Col_CC_B1_MX016_NX016_KX01_unroll;
              return;
            }
          } // end size
        } // end beta
      } // end transB
    } // end transA
  } // end order
} // end precision function

